<template>
  <div
    class="window"
    ref="window"
    :style="{
      'height': height + 'px',
      'width': width + 'px',
      'left': left + 'px',
      'top': top + 'px',
    }">
    <!-- <div class="control lt" @mousedown="enableResize"></div>
    <div class="control mt"></div>
    <div class="control rt"></div>
    <div></div>
    <div></div>
    <div></div>
    <div></div>
    <div></div> -->
    <div class="window-top" @mousedown="enableDrag" @dblclick="toggleWindow">
      <span class="dot"></span>
      <span class="dot"></span>
      <span class="dot"></span>
    </div>
    <div class="window-body">
      <div :is="component"></div>
    </div>
  </div>
</template>

<script>
import anime from "animejs";
import {mapMutations} from "vuex";

export default {
  props: {
    componentURI: String,
    zIndex: Number,
    id: Number,
  },
  data() {
    return {
      component: () => import(`${this.componentURI}`),
      clientHeight: 0,
      clientWidth: 0,
      height: 0,
      width: 0,
      left: 0,
      top: 0,
      docLeft: 0,
      docTop: 0,
      docWidth: 0,
      docHeight: 0,
      zindex: this.zIndex,
      draggable: false,
      resizable: false,
      state: {
        max: false,
        lastState: {
          x: '',
          y: '',
          width: '',
          height: '',
        }
      }
    }
  },
  methods: {
    initClientSize() {
      this.clientHeight = document.documentElement.clientHeight;
      this.clientWidth = document.documentElement.clientWidth;
    },
    onResize() {
      if (
        this.$children[0] &&
        this.$children[0].resize instanceof Function
      ) {
        this.$children[0].resize();
      }
    },
    changeWindow(height, width, left, top) {
      this.docHeight = this.height = height;
      this.docWidth = this.width = width;
      this.docLeft = this.left = left;
      this.docTop = this.top = top;
      this.onResize();
    },
    enableDrag(e) {
      this.draggable = true;
      e.preventDefault();

      document.addEventListener("mousemove", this.moveWindow);
      document.addEventListener("mouseup", this.removeWindowMoveListener);
      const changePosition = () => {
        if (this.draggable) {
          this.left = this.docLeft;
          this.top = this.docTop;
          requestAnimationFrame(changePosition);
        }
      }
      changePosition();
    },
    moveWindow(e) {
      if (this.draggable) {
        this.docLeft += e.movementX;
        this.docTop += e.movementY;
      }
    },
    removeWindowMoveListener() {
      this.draggable = false;
      document.removeEventListener("mousemove", this.moveWindow);
      document.removeEventListener("mouseup", this.removeWindowMoveListener);
    },
    enableResize(e) {
      this.resizable = true;
      e.preventDefault();

      document.addEventListener("mousemove", this.resizeWindow);
      document.addEventListener("mouseup", this.removeWindowResizeListener);

      const runResizeWindow = () => {
        if (this.resizable) {
          this.left = this.docLeft;
          this.top = this.docTop;
          this.width = this.docWidth;
          this.height = this.docHeight;
          requestAnimationFrame(runResizeWindow);
        }
      }
      runResizeWindow();
    },
    resizeWindow(e) {
      if (this.resizable) {
        this.docLeft += e.movementX;
        this.docTop += e.movementY;
        this.docWidth -= e.movementX;
        this.docHeight -= e.movementY;
      
        this.onResize();
      }
    },
    removeWindowResizeListener() {
      this.draggable = false;
      document.removeEventListener("mousemove", this.resizeWindow);
      document.removeEventListener("mouseup", this.removeWindowResizeListener);
    },
    async toggleWindow() {
      this.state.max = !this.state.max;

      if (this.state.max) {
        // store state for backup
        this.state.lastState.x = this.left;
        this.state.lastState.y = this.top;
        this.state.lastState.width = this.width;
        this.state.lastState.height = this.height;

        await new Promise((resolve) => {
          anime({
            targets: this.$refs.window,
            top: 25,
            left: 0,
            width: this.clientWidth,
            height: this.clientHeight - 78,
            easing: 'easeInOutQuad',
            duration: 300,
            complete () {
              resolve()
            }
          });
        });
        this.height = this.clientHeight - 78;
        this.width = this.clientWidth;
        this.docLeft = this.left = 0;
        this.docTop = this.top = 25;
      } else {
        // backup state
        await new Promise((resolve) => {
          anime({
            targets: this.$refs.window,
            top: this.state.lastState.y,
            left: this.state.lastState.x,
            width: this.state.lastState.width,
            height: this.state.lastState.height,
            easing: 'easeInOutQuad',
            duration: 300,
            complete () {
              resolve()
            }
          });
        });
        this.height = this.state.lastState.height;
        this.width = this.state.lastState.width;
        this.docLeft = this.left = this.state.lastState.x;
        this.docTop = this.top = this.state.lastState.y;
      }

      this.onResize();
    },
    registRegroup() {
      this.$refs.window.addEventListener(
        'mousedown',
        () => this.regroupWindowsZindex(this.id),
        true
      );
    },
    ...mapMutations({
      regroupWindowsZindex: 'os/regroupWindowsZindex',
    })
  },
  mounted() {
    this.initClientSize();
    window.onresize = () => this.initClientSize();

    this.changeWindow(
      this.clientHeight * .5,
      this.clientWidth * .5,
      this.clientWidth * .25,
      this.clientHeight * .25
    );

    this.registRegroup();
  }
}
</script>

<style>
.window {
  --radius-size: 6px;
  --shadow-setting: 0 0 30px rgba(0, 0, 0, 0.8);
  --space-size: 4px;

  border-radius: var(--radius-size);
  box-shadow: var(--shadow-setting);
  position: absolute;
}
.window .window-top {
  padding: var(--space-size);
  background: hsl(209, 71%, 7%);
  border-top-left-radius: var(--radius-size);
  border-top-right-radius: var(--radius-size);
  overflow: hidden;
}
.window .dot {
  --dot-size: 12px;
  --dot-background: #bbb;

  height: var(--dot-size);
  width: var(--dot-size);
  margin-left: var(--space-size);
  background-color: var(--dot-background);
  border-radius: 50%;
  display: inline-block;
}
.window .window-body{
  position: relative;
  border-bottom-left-radius: var(--radius-size);
  border-bottom-right-radius: var(--radius-size);
  height: calc(100% - 22px);
  overflow: hidden;
}
.window .control{
  --border-size: 8px;
}
.window .lt{
  position: absolute;
  height: var(--border-size);
  width: var(--border-size);
  left: calc(var(--border-size) * -0.5);
  top: calc(var(--border-size) * -0.5);
  background-color: #fff;
}
.window .lt:hover{
  cursor: nw-resize;
}
.window .mt{
  position: absolute;
  height: var(--border-size);
  width: calc(100% - var(--border-size));
  left: calc(var(--border-size) * 0.5);
  top: calc(var(--border-size) * -0.5);
  background-color: #fff;
}
.window .mt:hover{
  cursor: n-resize;
}
.window .rt{
  position: absolute;
  height: var(--border-size);
  width: var(--border-size);
  right: calc(var(--border-size) * -0.5);
  top: calc(var(--border-size) * -0.5);
  background-color: #fff;
}
</style>
